#pragma once

#include <J3ML/LinearAlgebra/EulerAngle.hpp>
#include <J3ML/LinearAlgebra/Quaternion.hpp>
#include <J3ML/LinearAlgebra/Vector3.hpp>

namespace J3ML::LinearAlgebra {
    class AxisAngle;
}

/// Transitional datatype, not useful for internal representation of rotation
/// But has uses for conversion and manipulation.
class J3ML::LinearAlgebra::AxisAngle {
public:
    Vector3 axis;
    // Radians.
    float angle;
public:
    AxisAngle();
    explicit AxisAngle(const Quaternion& q);
    explicit AxisAngle(const EulerAngleXYZ& e);
    AxisAngle(const Vector3& axis, float angle);

};