#pragma once
#include <J3ML/LinearAlgebra/Vector3.hpp>

namespace J3ML::LinearAlgebra {
    class DirectionVectorRH;
}

/// Direction vector of a given Matrix3x3 RotationMatrix in a Right-handed coordinate space.
class J3ML::LinearAlgebra::DirectionVectorRH : public Vector3 {
private:
    // This is purposefully not exposed because these types aren't usually convertable.
    explicit DirectionVectorRH(const Vector3& rhs);
public:
    static DirectionVectorRH Forward(const Matrix3x3& rhs);
    static DirectionVectorRH Backward(const Matrix3x3& rhs);
    static DirectionVectorRH Left(const Matrix3x3& rhs);
    static DirectionVectorRH Right(const Matrix3x3& rhs);
    static DirectionVectorRH Up(const Matrix3x3& rhs);
    static DirectionVectorRH Down(const Matrix3x3& rhs);
};